<template>
  <div class="content-block">
    <div class="container">
      <div class="margin-top-50"></div>
      <div class="row" ref="start">
        <div class="columns twelve central-column">
          <div class="content">
            <h3 class="main-header">Моя анкета</h3>
            <!--<img class="loader" v-if="false" src="/lk/static/img/loader-temp.gif">-->
              <div class="warning-block" v-show="isActivated" style="font-weight: normal">Редактирование анкетных данных на момент рассмотрения заявки запрещено</div>
              <BlockBlankFields v-if="showBlockBlank" />
              <div :class="{disabledBlock: isActivated}" class="text-overflow">
                <contact-give-money></contact-give-money>
                <profile-personal ref="inicialProfile"></profile-personal>
                <contact-information ref="contactInfoProfile"></contact-information>
                <additional-phone-profile ref="contactProfile"></additional-phone-profile>
                <passport-information ref="passportProfile"></passport-information>
                <address-fields ref="addressProfile" profile block></address-fields>
                <work-information-profile ref="workProfile"></work-information-profile>
                <snils ref="snilsOrInn" profile></snils>
                <additional-information ref="infoProfile"></additional-information>
                <publicity-profile ref="publicityProfile"></publicity-profile>
                <beneficial-profile ref="beneficialProfile"></beneficial-profile>

                <div class="row">
                  <div class="column">
                    <warning-message></warning-message>
                    <success-message></success-message>
                    <button :class="{button_loading: $interface.buttonLoading}"
                            :disabled="$interface.buttonLoading"
                            @click="updatedUser"
                    >Сохранить</button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
</template>

<script>
  import PersonalInformation from '@/components/User/PersonalInformation/'
  import ProfilePersonal from '@/components/User/PersonalInformation/ProfilePersonal/'
  import PassportInformation from '@/components/User/PassportInformation/'
  import ContactInformation from '@/components/User/ContactInformation/'
  import AdditionalPhoneProfile from '@/components/User/AdditionalPhone/'
  import WorkInformationProfile from '@/components/User/WorkInformation/'
  import AdditionalInformation from '@/components/User/AdditionalInformation/AdditionalInfo'
  import PublicityProfile from '@/components/User/PublicityInformation/'
  import BeneficialProfile from '@/components/User/BeneficialInformation/'
  import UserGetter from '@/mixins/User/UserGetterMixin/'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin/'
  import ContactGiveMoney from '@/components/TypeGetMoney/ContactGiveMoney/'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin/'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage/'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage/'
  import PasswordRecovery from '@/pages/PasswordRecovery/'
  import {focus} from '@/components/Validators/focus/'
  import BlockingForms from '@/mixins/BlockingForms/'
  import AddressFields from '@/components/User/Address/index/'
  import Snils from '@/components/User/SNILS/'
  import BlockBlankFields from './BlockBlankFields'
  import ErrorLog from '@/mixins/ErrorLog.js';

  export default {
    mixins: [
      UserGetter,
      ErrorHandleMixin,
      UserErrorText,
      BlockingForms,
      ErrorLog
    ],
    name: 'profile',
    components: {
      ProfilePersonal,
      ContactGiveMoney,
      ContactInformation,
      PersonalInformation,
      PassportInformation,
      AdditionalPhoneProfile,
      Snils,
      AddressFields,
      WorkInformationProfile,
      AdditionalInformation,
      PublicityProfile,
      BeneficialProfile,
      SuccessMessage,
      WarningMessage,
      PasswordRecovery,
      BlockBlankFields
    },
    data () {
      return {
        fieldsCounters: {}
      }
    },
    computed: {
      loaderButtonClass () {
        return this.$user.buttonActionLoaderClassProfile
      },
      showBlockBlank () {
      	if (this.$user.blankFields.length) { // проверяем, если незаполненные поля, которые присылает бэк
      	    if (this.$user.blankFields.some((k) => k === 'workINN') && this.$user.blankFields.length === 1) {
                return false // если с бэка пришло только одно поле workINN - то мы не показываем блок
      	    } else {
      	        return true // в остальных случаях блок виден, если пришел массив данных
      	    }
      	} else {
      	    return false // не показываем блок, если массив данных пуст
      	}
      },
      beginRedation () {
        return (JSON.stringify(this.fieldsCounters) === JSON.stringify(this.$user)) || this.$user.buttonSaveProfile
      }
    },
    mounted () {
        this.fieldsCounters = JSON.parse(JSON.stringify(this.$user));
        this.$nextTick(() => {
            const checked = []
            checked.push(this.$refs.inicialProfile.$validator.validateAll())
            checked.push(this.$refs.contactProfile.$validator.validateAll())
            checked.push(this.$refs.passportProfile.$validator.validateAll())
            checked.push(this.$refs.addressProfile.$validator.validateAll())
            checked.push(this.$refs.workProfile.$validator.validateAll())
            checked.push(this.$user.typeOfEmployment === 1 ? this.$refs?.workProfile?.$refs?.employee?.$validator?.validateAll() : true)
            checked.push(this.$user.typeOfEmployment === 1 ? this.$refs?.workProfile?.$refs?.WorkAddress?.$validator?.validateAll() : true)
            checked.push(this.$user.typeOfEmployment === 2 ? this.$refs?.workProfile?.$refs?.businessman?.$validator?.validateAll() : true)
            checked.push(this.$user.typeOfEmployment === 3 ? this.$refs?.workProfile?.$refs?.FounderFullName?.$validator?.validateAll() : true)
            checked.push(this.$user.typeOfEmployment === 3 ? this.$refs?.workProfile?.$refs?.businessman?.$validator?.validateAll() : true)
            // checked.push(this.$refs.snilsOrInn.$validator.validateAll())
            checked.push(this.$refs.infoProfile.$validator.validateAll())
            checked.push(this.$refs.publicityProfile.$validator.validateAll())
            checked.push(this.$refs.beneficialProfile.$validator.validateAll())
            let call = checked.every(key => {
                return key === true
            })
            if (call !== true) {
                this.$helpers.focus()
            }

            this.disableAutocomplite();
        });
    },
    methods: {
        disableAutocomplite () {
            const elements = document.querySelectorAll('input');
            console.log('elements', elements);
            [].forEach.call(elements, (e) => {
                if(['text', 'tel', 'number'].includes(e.type)) {
                    e.setAttribute('autocomplite', 'off');
                }
            })
        },
      async updatedUser () {
        const checked = []
        checked.push(await this.$refs.inicialProfile.$validator.validateAll())
        checked.push(await this.$refs.contactProfile.$validator.validateAll())
        checked.push(await this.$refs.passportProfile.$validator.validateAll())
        checked.push(await this.$refs.addressProfile.$validator.validateAll())
        checked.push(await this.$refs.workProfile.$validator.validateAll())
        checked.push(this.$user.typeOfEmployment === 1 ? await this.$refs.workProfile.$refs.employee.$validator.validateAll() : true)
        checked.push(this.$user.typeOfEmployment === 1 ? await this.$refs.workProfile.$refs.WorkAddress.$validator.validateAll() : true)
        // ИНН убран
        // checked.push(this.$user.typeOfEmployment === 2 ? await this.$refs.workProfile.$refs.businessman.$validator.validateAll() : true)
        checked.push(this.$user.typeOfEmployment === 3 ? await this.$refs.workProfile.$refs.FounderFullName.$validator.validateAll() : true)
        // ИНН убран
        // checked.push(this.$user.typeOfEmployment === 3 ? await this.$refs.workProfile.$refs.businessman.$validator.validateAll() : true)
        // checked.push(await this.$refs.snilsOrInn.$validator.validateAll())
        checked.push(await this.$refs.infoProfile.$validator.validateAll())
        checked.push(await this.$refs.publicityProfile.$validator.validateAll())
        checked.push(await this.$refs.beneficialProfile.$validator.validateAll())

        const addr = this.$refs.addressProfile
        if (!addr.fiases.street_fias_id && !addr.address.doNotHaveStreet) {
          addr.$refs.doNotHaveStreet.style.color = '#ff6d4a'
          this.$toastr.error('Необходимо указать улицу или нажать на галочку "Я подтверждаю, что по моему адресу регистрации улица отсутствует."')
          this.$helpers.scroll(addr.$refs.doNotHaveStreet)
          return false
        } else {
          if (addr.$refs.doNotHaveStreet) {
            addr.$refs.doNotHaveStreet.style.color = ''
          }
        }
        let flag = checked.every(key => {
          return key === true
        })
        if (flag) {
          this.BUTTON_LOADING(true)
          this.AJAX_LOADING(true);
          this.$store.dispatch('UPDATE_USER_DATA').then(async () => {
            this.fieldsCounters = JSON.parse(JSON.stringify(this.$user))
            this.$toastr.success('Анкетные данные успешно изменены', 'Успешно')
            // обновление анкеты и валидации (blankFields)
            await this.$methods.user.getUserData();
            this.$helpers.scroll(this.$refs.start);
          }).catch((e) => {

            if(Array.isArray(e.errors)) {
              e.errors.forEach((code) => {
                this.$errorField(typeof code === "object" ? code.code : code, 'profile_save');
                console.log('code', code);
              })
            }

            const mapper = require('../../utils/error_mapper/user').default;
            const errorMap = mapper[e.errors[0].code];
            if(errorMap) {
              this.$toastr.error(errorMap.message, 'Ошибка');
              this.$nextTick(() => {
                this.$helpers.focus();
              });
            } else {
              this.$toastr.error('Ошибка сохранения данных профиля.', 'Ошибка');
            }
          }).finally(() => {
            this.AJAX_LOADING(false);
            this.BUTTON_LOADING(false)

          });

        } else {
          this.$toastr.error('При редактировании неправильно заполнены обязательные поля. Пожалуйста, заполните их и снова нажмите кнопку сохранить.', 'Ошибка');
          this.$helpers.focus();
        }
      }
    },

  }
</script>

<style scoped lang="scss">

  .loader {
    display: block;
    margin: 0 auto;
  }

  .white {
    cursor: default;
    color: #b4cadd;
    background: #fff;
  }

  .white:hover {
    background: #fff;
  }
</style>

